## libaio-ocaml 1.0

=== Makefile ===
all:
	$(MAKE) -C lib $@

%:
	$(MAKE) -C lib $@

clean:
	$(MAKE) -C lib $@
	$(MAKE) -C examples $@

distclean:
	$(MAKE) -C lib $@
	$(MAKE) -C examples $@

test:
	$(MAKE) -C examples $@

=== examples/Makefile ===
test: test-byte $(if $(wildcard /usr/bin/ocamlopt),test-opt,)
	@: # Do not remove

test-byte:
	@echo "### Test byte code ###"
	$(MAKE) -C ../lib  byte-code-library
	ocamlc -I ../lib -o test.byte unix.cma bigarray.cma aio.cma test.ml
	./test.byte 2>&1 | tee test.out
	md5sum -c test.md5sum
	rm testfile test.out test.byte

test-opt:
	@echo "### Test native code ###"
	$(MAKE) -C ../lib  native-code-library
	ocamlopt -I ../lib -o test.opt unix.cmxa bigarray.cmxa aio.cmxa test.ml
	./test.opt 2>&1 | tee test.out
	md5sum -c test.md5sum
	rm testfile test.out test.opt
	@echo "### Test successfull ###"

clean:
	rm -f *.cmx *.cmi *.cmo *.o
	rm -f test.out testfile test.opt test.byte

distclean: clean

.NOTPARALLEL:

=== lib/Makefile ===
OCAMLMAKEFILE = ../OCamlMakefile

SOURCES   = aio_buffer.ml aio.mli aio.ml aio_stubs.c aio_buffer_stubs.c
CFLAGS    = -O2 -g -W -Wall
CLIBS	  = aio
RESULT    = aio

all: byte-code-library $(if $(wildcard /usr/bin/ocamlopt),native-code-library,)

install: $(if $(wildcard /usr/bin/ocamlopt),libinstall,libinstall-byte-code)
uninstall: libuninstall

distclean: clean
	rm -f .depend

-include $(OCAMLMAKEFILE)

=== debian/changelog ===
libaio-ocaml (1.0-1) experimental; urgency=low

  * Initial Release (Closes: 662763).

 -- Goswin von Brederlow <goswin-v-b@web.de>  Tue, 06 Mar 2012 02:02:36 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR := $(CURDIR)/debian/tmp

include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR := $(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_DLLDIR := $(DESTDIR)/$(OCAML_DLL_DIR)

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
  BUILD_TARGET := byte-code-library native-code-library
  INSTALL_TARGET := libinstall
else
  BUILD_TARGET := byte-code-library
  INSTALL_TARGET := libinstall-byte-code
endif

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(BUILD_TARGET)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR) $(OCAMLFIND_DLLDIR)
	$(MAKE) $(INSTALL_TARGET)
	rm $(OCAMLFIND_DLLDIR)/*.owner

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

# Make a release
release: SOURCE=$(shell dpkg-parsechangelog | awk '/^Source:/ { print $$2 }')
release: VERSION=$(shell dpkg-parsechangelog | awk '/^Version:/ { print $$2 }')
release: UPSTREAM_VERSION=$(shell VERSION="$(VERSION)"; echo $${VERSION%-*})
release: DIR=$(shell basename "$$(pwd)")
release: ORIG_NAME=../$(SOURCE)_$(UPSTREAM_VERSION).orig.tar.gz
release:
	@if [ "$(VERSION)" = $(UPSTREAM_VERSION) ]; then		\
	  echo "Error: Missing debian revision in $(VERSION).";		\
	  exit 1;							\
	fi
	@if [ -n "$(shell git status --porcelain)" ]; then		\
	  echo "Error: Uncommited changed.";				\
	  exit 1;							\
	fi
	@if ! git branch | grep -q "^* master$$"; then			\
	  echo "Error: Not in master branch.";				\
	  exit 1;							\
	fi
	@if git tag | grep -q "^debian/$(VERSION)$$"; then		\
	  echo "Error: Release $(VERSION) already exists.";		\
	  exit 1;							\
	fi
	@if git tag | grep -q "^upsteam/$(UPSTREAM_VERSION)$$"; then	\
	  echo "Upstream $(UPSTREAM_VERSION) already exists.";		\
	else								\
	  echo "Creating $(ORIG_NAME) ...";				\
	  git archive --format=tar.gz --output=$(ORIG_NAME)		\
		      --prefix=$(SOURCE)-$(UPSTREAM_VERSION)/		\
		      --worktree-attributes HEAD;			\
	  git-import-orig --no-merge --pristine-tar 			\
			  --upstream-version=$(UPSTREAM_VERSION)	\
			  $(ORIG_NAME);					\
	fi
	@echo "Tagging release debian/$(VERSION)"
	@git tag "debian/$(VERSION)"

## libaio-ocaml 1.0.1

=== debian/changelog ===
libaio-ocaml (1.0.1-1) experimental; urgency=low

  * Make test architecture independent.
  * Add get_{be,le,net}-{int,uint}8 aliases.
  * Preserve signedness when convertion endianness.

 -- Goswin von Brederlow <goswin-v-b@web.de>  Wed, 21 Mar 2012 17:16:52 +0100

=== debian/control ===
Source: libaio-ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Goswin von Brederlow <goswin-v-b@web.de>
Build-Depends: debhelper (>= 8~), libaio-dev, ocaml-nox (>= 3.11.1-3~), ocaml-findlib (>= 1.2.1-5), dh-ocaml (>= 0.9)
Standards-Version: 3.9.3
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/libaio-ocaml.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/libaio-ocaml.git
Homepage: http://forge.ocamlcore.org/projects/libaio-ocaml/

Package: libaio-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml bindings for libaio (Linux kernel AIO access library)
 This OCaml-library interfaces the libaio (Linux kernel AIO access
 library) C library. It can be used for fast asynchronous I/O.
 .
 Compared with the OCaml standard and Unix I/O functions this
 library:
  * does not block
  * does I/O in the background
  * calls a continuation when the I/O has completed
 .
 This package contains only the shared runtime stub libraries.

Package: libaio-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, libaio-dev (>= 0.3), ocaml-findlib (>= 1.1)
Provides: ${ocaml:Provides}
Description: OCaml bindings for libaio (Linux kernel AIO access library) (devel)
 This OCaml-library interfaces the libaio (Linux kernel AIO access
 library) C library. It can be used for fast asynchronous I/O.
 .
 Compared with the OCaml standard and Unix I/O functions this
 library:
  * does not block
  * does I/O in the background
  * calls a continuation when the I/O has completed
 .
 This package contains all the development stuff you need to use
 OCaml aio in your programs.

=== debian/rules ===
--- 
+++ 
@@ -56,7 +56,8 @@
 	  echo "Error: Release $(VERSION) already exists.";		\
 	  exit 1;							\
 	fi
-	@if git tag | grep -q "^upsteam/$(UPSTREAM_VERSION)$$"; then	\
+	@set -e;							\
+	if git tag | grep -q "^upsteam/$(UPSTREAM_VERSION)$$"; then	\
 	  echo "Upstream $(UPSTREAM_VERSION) already exists.";		\
 	else								\
 	  echo "Creating $(ORIG_NAME) ...";				\
@@ -66,6 +67,10 @@
 	  git-import-orig --no-merge --pristine-tar 			\
 			  --upstream-version=$(UPSTREAM_VERSION)	\
 			  $(ORIG_NAME);					\
+	  echo "Merging into upstream";					\
+	  git checkout upstream;					\
+	  git merge -s ours master;					\
+	  git checkout master;						\
 	fi
 	@echo "Tagging release debian/$(VERSION)"
 	@git tag "debian/$(VERSION)"
